function encrypt() {
	openpgp.init();
	var pub_key = openpgp.read_publicKey(jQuery('#pgp_key_generator_pubkey').val());
	jQuery('#pgp_key_generator_message_encrypt').val(openpgp.write_encrypted_message(pub_key,jQuery('#pgp_key_generator_message_encrypt').val()));
	return false;
}

function generate() {
	openpgp.init();
	var pgp_key_user = jQuery('#pgp_key_generator_username').val() + ' <' + jQuery('#pgp_key_generator_mail_address').val() + '>';
	var keys = openpgp.generate_key_pair(1, jQuery('#pgp_key_generator_key_length').val(), pgp_key_user, jQuery('#pgp_key_generator_key_password').val());
	jQuery('#pgp_key_generator_privgenkey').val(keys.privateKeyArmored);
	jQuery('#pgp_key_generator_pubgenkey').val(keys.publicKeyArmored);
	return false;
}

function decrypt() {
	openpgp.init();
	var priv_key = openpgp.read_privateKey(jQuery('#pgp_key_generator_privkey').val());
	var msg = openpgp.read_message(jQuery('#pgp_key_generator_message_decrypt').val());

	var keymat = null;
	var sesskey = null;
	
	// Find the private (sub)key for the session key of the message
	for (var i = 0; i< msg[0].sessionKeys.length; i++) {
		if (priv_key[0].privateKeyPacket.publicKey.getKeyId() == msg[0].sessionKeys[i].keyId.bytes) {
			keymat = { key: priv_key[0], keymaterial: priv_key[0].privateKeyPacket};
			sesskey = msg[0].sessionKeys[i];
			break;
		}
		for (var j = 0; j < priv_key[0].subKeys.length; j++) {
			if (priv_key[0].subKeys[j].publicKey.getKeyId() == msg[0].sessionKeys[i].keyId.bytes) {
				keymat = { key: priv_key[0], keymaterial: priv_key[0].subKeys[j]};
				sesskey = msg[0].sessionKeys[i];
				break;
			}
		}
	}
	
	if (keymat != null) {
		if (!keymat.keymaterial.decryptSecretMPIs( jQuery('#pgp_key_generator_key_password_decrypt').val() )) {
			alert("Password for secrect key was incorrect!");
			return false;
		}
		jQuery('#pgp_key_generator_message_decrypt').val(msg[0].decrypt(keymat, sesskey));
		return false;
	} else {
		alert("No private key found!");
		return false;
	}
	return false;
}

jQuery(document).ready(function(){
	jQuery("#pgp_key_generator_form1_button").click(function() { jQuery("#pgp_key_generator_form1").submit(); });
	jQuery("#pgp_key_generator_form1").validate({
		rules:{
			pgp_key_generator_username:{
				required: true
			},
			pgp_key_generator_mail_address:{
				required: true,
				email: true
			}
		},
		submitHandler: function(form) {
			return generate();
		}
	});
	
	jQuery("#pgp_key_generator_form2_button").click(function() { jQuery("#pgp_key_generator_form2").submit(); });
	jQuery("#pgp_key_generator_form2").validate({
		rules:{
			pgp_key_generator_message_encrypt:{
				required: true
			},
			pgp_key_generator_pubkey:{
				required: true
			}
		},
		submitHandler: function(form) {
			return encrypt();
		}
	});
	
	jQuery("#pgp_key_generator_form3_button").click(function() { jQuery("#pgp_key_generator_form3").submit(); });
	jQuery("#pgp_key_generator_form3").validate({
		rules:{
			pgp_key_generator_message_decrypt:{
				required: true
			},
			pgp_key_generator_privkey:{
				required: true
			}
		},
		submitHandler: function(form) {
			return decrypt();
		}
	});
});